<?php
/*  Feed2inc : RSS feed to PHP include file
	
	ABOUT
	This PHP code can be used as an include to provide the
	same functionality of our Feed2JS concept, but without
	the need to generate content via JavaScript
	
	Developed by Alan Levine 04.aug.2004
	http:/jade.mcli.dist.maricopa.edu/cdb/
	
	This is a modified version of Fee22JS and merely replaces
	the output of Javascript to that for a PHP. See the original
	feed2js.php for change history.
	 
	USAGE:
	See http://jade.mcli.dist.maricopa.edu/feed/index.php?s=php
	
	
	Local customization can be achieved via declarations of CSS for
	  div.rssbox (style for bounding box)
	  class.rss_title (style for title of feed)
	  class.rss_item, class.rss_item a (style for linked entry)
	  class.rss_date (style for date display)
	
	HISTORY
    I got tired of keeping this up to date, see:
      http://jade.mcli.dist.maricopa.edu/feed/index.php?s=history
    
    or the RSS feed:
      http://jade.mcli.dist.maricopa.edu/feed//content/feed2js.xml

	
	This makes use of the Magpie RSS parser from
	 http://magpierss.sourceforge.net/
	 
	which should be downloaded and installed separately.
	
   ------------- small print ---------------------------------------
	GNU General Public License 
	Copyright (C) 2004 Alan Levine
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details
	http://www.gnu.org/licenses/gpl.html
	------------- small print ---------------------------------------

*/

require_once('scripts/feed2js_config.php');

/// trap for missing src param for the feed, use a dummy one so it gets displayed.
if (!$src or strpos($src, 'http://')!=0) $src = "http://jade.mcli.dist.maricopa.edu/feed/nosource.rss";

//  check for utf encoding type
if (!isset($utf)) $utf = 'n';

if ($_GET['utf'] == 'y' || $utf == 'y') {
//	define('MAGPIE_CACHE_DIR', MAGPIE_DIR . 'cache_utf8/');
	// chacrater encoding
//	define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');
    if (! is_dir('content/rss_cache_utf8/')){
	mkdir('content/rss_cache_utf8/',0755);
    }
    define('MAGPIE_CACHE_DIR', 'content/rss_cache_utf8/');
    // chacrater encoding
    define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');

} else {
//	define('MAGPIE_CACHE_DIR', MAGPIE_DIR . 'cache/');
    if (! is_dir('content/rss_cache/')){
	mkdir('content/rss_cache/',0755);
    }
    define('MAGPIE_CACHE_DIR', 'content/rss_cache/');
}


// GET VARIABLES ---------------------------------------------
// retrieve values from posted variables

// flag to show channel info
if (!isset($chan)) $chan = 'n';

// variable to limit number of displayed items; default = 0 (show all, 20 is a safe bet to list a big list of feeds)

if (!isset($num)) $num = 0;
if ($num==0) $num = 20;

// indicator to show item description,  0 = no; 1=all; n>1 = characters to display
// values of -1 indicate to displa item without the title as a link
// (default=0)
if (!isset($desc)) $desc = 0;

// flag to show date of posts, values: no/yes (default=no)
if (!isset($date)) $date = 'n';

// flag to open target window in new window; n = same window, y = new window,
// other = targeted window, 'popup' = call JavaScript function popupfeed to display
// in new window
// (default is n)

if (!isset($targ)) $targ = 'n';

if ($targ == 'n') {
	$target_window = ' target="_self"';
} elseif ($targ == 'y' ) {
	$target_window = ' target="_blank"';
} elseif ($targ == 'popup') {
	$target_window = ' target="popup" onClick="popupfeed(this.href);return false"';
} else {
	$target_window = ' target="' . $targ . '"';
}

// flag to show feed as full html output rather than JavaScript, used for alternative
// views for JavaScript-less users. 
//     y = display html only for non js browsers
//     n = default (JavaScript view)
//     a = display javascript output but allow HTML 
//     p  = display text only items but convert linefeeds to BR tags

// default setting for no conversion of linebreaks
if (!isset($html)) $html = 'n';

$br = ' ';
if ($html == 'a') {
	$desc = 1;
} elseif ($html == 'p') {
	$br = '<br />';
}

// optional parameter to use different class for the CSS container
if (isset($css)) {
	$rss_box_id = '_' . $css;
} else {
	$rss_box_id = '';
}

// PARSE FEED and GENERATE OUTPUT -------------------------------
// This is where it all happens!

// Fetch the data, thanks Magpie
$rss = @fetch_rss( $src );

if ($rss->image['url']){
    if (!isset($channel_img)){
	$channel_img = $rss->image['url'];
    }
}

// begin javascript output string for channel info
$str = "<div class=\"rss_box" . $rss_box_id . "\">";

if  (!$rss->channel['link']) {
	// error, nothing grabbed
	$str.= "<p class=\"rss_item\"><em>Error:</em> Feed failed! Causes may be (1) No data  found for RSS feed $src; (2) There are no items are available for this feed; (3) The RSS feed does not validate.<br /><br /> Please verify that the URL <a href=\"$src\">$src</a> works first in your browser and that the feed passes a <a href=\"http://feedvalidator.org/check.cgi?url=" . urlencode($src) . "\">validator test</a>.</p></div>";
} else {

	if ($chan == 'y') {

	    if ($channel_img){
		$str.="<p class=\"rss_title\"><a class=\"rss_title\" href=\"". 
		    trim($rss->channel['link']) . 
		    "\" target=\"" . 
		    $target_window . 
		    "\"><img src=\"" . 
		    $channel_img . 
		    "\" alt=\"" . 
		    strip_returns($rss->channel['title']) . 
		    ' - ' . strip_returns($rss->channel['description']) . 
		    "\" /></a><br /><span class=\"rss_item\">" . 
		    strip_returns($rss->channel['description']) . 
		    "</span></p>";
	    } else{
		// output channel title and description	
		$str.= "<p class=\"rss_title\"><a class=\"rss_title\" href=\"" . trim($rss->channel['link']) . "\" target=\"" . $target_window . "\">" . strip_returns($rss->channel['title']) . "</a><br /><span class=\"rss_item\">" . strip_returns($rss->channel['description']) . "</span></p>";
	    }
	} elseif ($chan == 'title') {
		// output title only
		$str.= "<p class=\"rss_title\"><a class=\"rss_title\" href=\"" . trim($rss->channel['link']) . "\" target=\"" . $target_window . "\">" . strip_returns($rss->channel['title']) . "</a></p>";
	
	} 

	
	// begin item listing
	$str.= "<ul class=\"rss_items\">";
	
	
	// Walk the items and process each one
	$all_items = array_slice($rss->items, 0, $num);
	
	foreach ( $all_items as $item ) {
		
		if ($item['link']) {
			// link url
			$my_url = $item['link'];
		} elseif  ($item['guid']) {
			//  feeds lacking item -> link
			$my_url = ($item['guid']);
		}
		
		
		if ($desc < 0) {
			$str.= "<li class=\"rss_item\">";
			
		} elseif  ($item['title']) {
			// format item title
			$my_title = strip_returns($item['title']);

			// create a title attribute. thanks Seb!
			$title_str = substr(strip_returns(strip_tags($item['summary'])), 0, 255) . '...'; 

			// write the item
			$str.= "<li class=\"rss_item\"><a class=\"rss_item\" href=\"" . trim($my_url) . "\"  title=\"$title_str\"" . $target_window . ">" . $my_title . "</a><br />";

		} else {
			// if no title, build a link to tag on the description
			$str.= "<li class=\"rss_item\">";
			$more_link = " <a class=\"rss_item\" href=\"" .trim($my_url) . '"' . $target_window . ">&laquo;details&raquo;</a>";
		}

	
		// print out date if option indicated and feed returns a value. 
		// Use the new date_timestamp function in Magpie 0.71
		if ($date == 'y') {
//   NOT working now on RSS 2.0 feeds, help Magpie!!		
//			$pretty_date = date($date_format, $item['date_timestamp']);


// use the old approach until Magpie is fixed
			// 2005-11-09 Note: Up to now, the date stamp was creating dates
			// in the server's time zone; until we fix it, we resort to
			// just blitting out the date format as stored in the feed

			if ($item['pubdate'] != '') {
				// RSS 2.0 is alreayd formatted, so just use it
				$pretty_date = $item['pubdate'];
				
			} elseif ($item['issued'] != "") {
				// ATOM format, remove the "T" and "Z" and the time zone offset
				$pretty_date = str_replace("T", " ", $item['issued']);
				$pretty_date= str_replace("Z", " ", $pretty_date);


			} elseif ( $item['dc']['date'] != "") {
				// RSS 1.0, remove the "T" and the time zone offset
				$pretty_date = str_replace("T", " ", $item['dc']['date']);
				$pretty_date = substr($pretty_date, 0,-6);
			} else {
			
				// no time/date stamp, just use the server time
				$pretty_date =  date($date_format);
			}


			$str.= "<span class=\"rss_date\">posted on $pretty_date</span><br />"; 
		}
		
	
		// output description of item if desired
		if ($desc) {

		 	// Atom/encocded content support (thanks David Carter-Tod)

			if ($item['content']['encoded']) {
				$my_blurb = $item['content']['encoded'];
	
			} else {   
				$my_blurb = $item['summary'];
			}



			// strip html
			if ($html != 'a') $my_blurb = strip_tags($my_blurb);
			
			// trim descriptions
			if ($desc > 1) {
			
				// display specified substring numbers of chars;
				//   html is stripped to prevent cut off tags
				$my_blurb = substr($my_blurb, 0, $desc) . '...';
			}
			$str.= '<div class="rss_desc">';
			$str.= strip_returns($my_blurb, $br);
			$str.= "</div>"; 
		}
			
		$str.= "$more_link</li>";	
	}
}

$str .= "</ul></div>";
// echo $str;

?>
